<template>
  <div>
    <q-card>
      <q-card-section>
        <q-item-label class="text-h6">
          Informasi Produk
        </q-item-label>
      </q-card-section>
      <q-card-section>
        <q-select
          style="width: 100%; margin-bottom: 20px"
          v-model="product.id_product_type"
          emit-value
          map-options
          label="Pilih Tipe Produk"
          :options="selectProductType"
          standout="bg-green text-white"
          @input="pilihKategori(false)"
          hint="Jenis Produk Menentukan dimana produk anda akan ditampilkan dan diklarifikasi." />
        <q-select
          v-model="product.id_category"
          emit-value
          map-options
          label="Pilih Kategori"
          :options="optionKategori"
          standout="bg-green text-white"
          v-if="product.id_product_type"
          hint="Pilih salah satu kategori yang anda masukan ketika membuat provider." />
      </q-card-section>
      <q-separator />
      <q-card-section v-if="productType">
        <form-product-jasa
          @inputProduct="inputProduct"
          :product="this.product"
          v-if="productType.is_jasa == 1 && product.id_category"
        />
        <form-product-lowongan
          @submit="submitProduct"
          :formTambahan="formTambahan"
          v-if="productType.is_jasa == 0 && product.id_category"
        />
      </q-card-section>
      <q-card-actions>
        <q-btn @click="$emit('prevStep')" label="Kembali" align="left" icon="arrow_left" color="orange" />
        <q-space />
        <q-btn
          @click="submitProduct"
          label="Selanjutnya"
          align="right"
          icon="arrow_right"
          color="green"
          v-if="this.product.id_product_type && this.product.id_category"
        />
      </q-card-actions>
    </q-card>
  </div>
</template>

<script>
import FormProductJasa from "components/Product/FormProductJasa";
import FormProductLowongan from "components/Product/FormProductLowongan";
export default {
  name: 'Step2Product',
  components: {
    FormProductJasa,
    FormProductLowongan
  },
  data () {
    return {
      productType: null,
      kategori: null,
      product: this.$attrs.product,
      optionKategori : null,
      formTambahan: []
    }
  },
  mounted() {
    window.scrollTo(0,0);
    if (this.$attrs.product.id_product_type == 0) {
      this.$attrs.product.id_product_type = null
      this.product.id_product_type = null
    }
    if (this.product.name == 'draft') {
      this.product.name = null
    }
    if (this.product.id_product_type != 0) {
      this.pilihKategori(true)
    }
  },
  methods: {
    submitProduct() {
      let formData = new FormData()
      formData.append("id_product_type", this.product.id_product_type)
      formData.append("id_category", this.product.id_category)
      formData.append("name_product", this.product.name_product)
      formData.append("desc_product", this.product.desc_product)
      formData.append("price", this.product.price)
      formData.append("starting_price", this.product.starting_price)
      formData.append("final_price", this.product.final_price)
      if (this.product.price_prone_flag) {
        formData.append("price_prone_flag", 1)
      } else {
        formData.append("price_prone_flag", 0)
      }
      formData.append("level", this.product.level)
      formData.append("id_unit_price", this.product.id_unit_price)
      this.$q.loading.show()
      this.$axios.post("api/product/information/create", formData)
      .then(sukses => {
        this.$q.loading.hide()
        this.$emit("sendCustomForm", this.productType.form)
        this.$emit("nextStep", sukses.data)
        console.log(sukses)
      })
    },
    inputProduct(product) {
      this.product = product
    },
    pilihKategori(mounted = false) {
      this.optionKategori = this.selectKategori.filter(data => {
        return data.product_type == this.product.id_product_type;
      })
      if (!mounted) {
        this.product.id_category = null
      }
      this.productType = this.selectProductType.filter(data => {
        return data.value == this.product.id_product_type
      })[0]
    },
  },
  computed: {
    selectKategori() {
      return this.$store.state.kategori.selectKategori;
    },
    selectProductType() {
      return this.$store.state.ProductType.selectProductType;
    }
  }
}
</script>
